package org.xbib.gradle.plugin.c;

import org.gradle.api.Plugin;
import org.gradle.api.Project;
import org.xbib.gradle.plugin.c.toolchain.transform.ExtractZipTransform;
import static org.gradle.api.artifacts.type.ArtifactTypeDefinition.ARTIFACT_TYPE_ATTRIBUTE;

@SuppressWarnings("unused")
abstract public class CPlugin implements Plugin<Project> {

    @Override
    public void apply(final Project project) {
        // Register extension
        project.getExtensions().create("c", CExtension.class);
        // Make the ExtractZipTransform known
        project.getDependencies().getAttributesSchema().attribute(CExtension.EXTRACTED_TOOLS_ATTRIBUTE);
        project.getDependencies().getArtifactTypes().maybeCreate("zip")
                .getAttributes().attribute(CExtension.EXTRACTED_TOOLS_ATTRIBUTE, false);
        project.getDependencies().registerTransform(ExtractZipTransform.class, t -> {
            t.getFrom().attribute(CExtension.EXTRACTED_TOOLS_ATTRIBUTE, false).attribute(ARTIFACT_TYPE_ATTRIBUTE, "zip");
            t.getTo().attribute(CExtension.EXTRACTED_TOOLS_ATTRIBUTE, true).attribute(ARTIFACT_TYPE_ATTRIBUTE, "zip");
        });
    }
}
