package org.xbib.gradle.plugin.jacc

import org.gradle.api.DefaultTask
import org.gradle.api.tasks.InputFiles
import org.gradle.api.tasks.OutputDirectory
import org.gradle.api.tasks.TaskAction
import org.xbib.jacc.Jacc

class JaccTask extends DefaultTask {

    @InputFiles
    Iterable<File> source

    @OutputDirectory
    File target

    @TaskAction
    void generateAndTransformJacc() throws Exception {
        source.each { file ->
            String pkg = getPackageName(file)
            File fullTarget = new File(target, pkg.replace('.','/'))
            project.mkdir(fullTarget)
            Jacc.main([file.absolutePath, '-d', fullTarget] as String[])
        }
    }

    static String getPackageName(File file) {
        String string = file.readLines().find { line ->
            line.startsWith('package ') || line.startsWith('%package ')
        }
        if (string == null) {
            return ''
        }
        int pos = string.indexOf(' ')
        string = string.substring(pos + 1).replace(';', '')
    }
}
