package org.xbib.gradle.plugin.jpackage;

import org.gradle.api.NonNullApi;
import org.gradle.api.Plugin;
import org.gradle.api.Project;
import org.gradle.api.file.SourceDirectorySet;
import org.gradle.api.plugins.JavaPlugin;
import org.gradle.api.tasks.SourceSetContainer;

@SuppressWarnings("unused")
@NonNullApi
public abstract class JPackagePlugin implements Plugin<Project> {

    @Override
    public void apply(Project project) {
        project.getPlugins().apply(JavaPlugin.class);
        SourceSetContainer sourceSets = project.getExtensions().getByType(SourceSetContainer.class);
        SourceDirectorySet mainResources = sourceSets.getByName("main").getResources();
        JPackageExtension jPackageExtension = project.getExtensions().create("jpackage", JPackageExtension.class);
        jPackageExtension.getApplicationName().convention(project.getName());
        jPackageExtension.getApplicationVersion().convention(project.provider(() ->
                (String) project.getVersion()));
        jPackageExtension.getJpackageResources().convention(project.provider(() ->
                project.getLayout().getProjectDirectory().dir(mainResources.getSrcDirs().iterator().next().getParent() + "/resourcesPackage")));
    }
}
